import greenfoot.*;

/**
 * Write a description of class FlappyBird here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class FlappyBird extends Actor
{
    double dy = 0;
    double g = .4;
    double BOOST_SPEED = -6;
    GreenfootImage upWing = new GreenfootImage("flappybird1.png");
    GreenfootImage downWing = new GreenfootImage("flappybird3.png");
    GreenfootImage straightWing = new GreenfootImage("flappybird2.png");
    int animFrame = 1;
    boolean invincible = false;
    int in_counter = -8;
    
    public FlappyBird()
    {
        setImage(straightWing);
    }

    /**
     * Act - do whatever the FlappyBird wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        //Game over checkers

        if (((FlappyWorld)(getWorld())).isPaused == false) {
            if (!invincible)
            {
                if (getOneIntersectingObject (BottomPipe.class) != null)
                {
                    displayGameOver();
                }
                if (getOneIntersectingObject (TopPipe.class) != null)
                {
                    displayGameOver();
                }
            }
            if (getY() > getWorld().getHeight())
            {
                displayGameOver();
            }
            if (getY() < -10)
            {
                setLocation(getX(), -10);
            }    
            //Set location if the game method isn't finished
            setLocation( getX(), (int) (getY() + dy));
            //Is up key pressed?

            if ("up".equals(Greenfoot.getKey()))
            {
                clicked();
            }
            if (Greenfoot.mouseClicked(null))
            {
                clicked();
            }
            //changed rotation
            if (dy < 0)
            {
                setRotation(-30);
            }
            else if(dy < 5)
            {
                setRotation(30);
            }
            else 
            {
                setRotation(60);

            }
            dy = dy +g;
            animFrame++;
            if (animFrame == 5)
            {
                setImage(straightWing);
            }
            if (animFrame == 8)
            {
                setImage(downWing);
            }
            if (animFrame == 12)
            {
                setImage(straightWing);
            }
            if (animFrame == 16)
            {
                setImage(upWing);
            }
        }
        if (((FlappyWorld)(getWorld())).score == in_counter + 7)
        {
            GetReadie getReadie = new GetReadie();
            getWorld().addObject(getReadie, getWorld().getWidth()/2, getWorld().getHeight()+50);
        }

        if (((FlappyWorld)(getWorld())).score == in_counter + 8)
        {
            invincible = false;
            getWorld().removeObjects(getWorld().getObjects(GetReadie.class));
        }
        if (getOneIntersectingObject(Coin.class) != null)
        {
            Coin coin = (Coin) getOneIntersectingObject(Coin.class);
            getWorld().removeObject(coin);
            Greenfoot.playSound("invincible.wav");
            invincible = true;
            in_counter = (((FlappyWorld)(getWorld())).score);
        }
    }

    private void clicked()
    {
        Greenfoot.playSound("wing.wav");
        dy = BOOST_SPEED;
        setImage(upWing);
        animFrame = 0;
    }

    private void displayGameOver()
    {
        Greenfoot.playSound("hit.wav");
        GameOver gameOver = new GameOver();
        getWorld().addObject(gameOver, getWorld().getWidth()/2, getWorld().getHeight()/2);
        Greenfoot.stop();
    }

}
