import greenfoot.*;

/**
 * Write a description of class FlappyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class FlappyWorld extends World
{
    int pipeCounter = 0;
    int SPACE_BETWEEN_PIPES = getHeight();
    int score = 0;
    int FIRST_PIPE = 240;
    int flappyCounter = 0;
    Score scoreObj = null;
    Start start = new Start();
    Title title = new Title();
    GetReady getReady = new GetReady();
    boolean isPaused = true;
    boolean justPaused = true;
    boolean getready = false;
   
    public FlappyWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1, false);

        //set paint order
        setPaintOrder(Score.class, GameOver.class, FlappyBird.class, BottomPipe.class, TopPipe.class);
        //Create a Flappy bird obj
        FlappyBird flappy = new FlappyBird();

        //Add flappy to our world
        addObject(flappy, 100, getHeight()/2);

        //Score obj created
        scoreObj = new Score();
        scoreObj.setScore(0);
        //add score to workd
        addObject(scoreObj, 60, 375);
        addObject(start, getWidth()/2, getHeight()/2);
        addObject(title, getWidth()/2, getHeight()/4);
        Greenfoot.start();

        prepare();
    }

    public void act()
    {
        if (Greenfoot.mouseClicked(null) && getready)
        {
            removeObjects(getObjects(GetReady.class));
            isPaused = false;
        }

        if (Greenfoot.mouseClicked(start))
        {
            addObject(getReady, getWidth()/2, getHeight()/2);
            removeObjects(getObjects(Start.class));
            removeObjects(getObjects(Title.class));
            getready = true;
        }

        if (isPaused == false) {
            pipeCounter++;
            if (pipeCounter % 100 == 0)
            {
                createPipes();
            }
            if (pipeCounter >= FIRST_PIPE)
            {
                if (flappyCounter % 100 == 0)
                {
                    score++;
                    Greenfoot.playSound("point.wav");
                    scoreObj.setScore(score);
                }
                flappyCounter++;

            }
        }

    }

    private void createPipes()
    {
        BottomPipe bottomPipe = new BottomPipe();
        TopPipe topPipe = new TopPipe();
        addObject(topPipe, getWidth(),  Greenfoot.getRandomNumber(getHeight()/2) - getHeight()/4);
        addObject( bottomPipe, getWidth(), topPipe.getY() + SPACE_BETWEEN_PIPES); 
        if (Greenfoot.getRandomNumber(30) == 0)
        {
            Coin coin = new Coin();
            addObject( coin, getWidth(), topPipe.getY() +  200 );

        }

    }

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
    }
}
